"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.defaultProps = exports.model = exports.hasOne = exports.hasMany = exports.relation = undefined;
exports.extendModelInstance = extendModelInstance;

var _index = require("./index");

var _index2 = _interopRequireDefault(_index);

var _idx = require("idx");

var _idx2 = _interopRequireDefault(_idx);

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var relation = exports.relation = {
  from: function (_from) {
    function from(_x) {
      return _from.apply(this, arguments);
    }

    from.toString = function () {
      return _from.toString();
    };

    return from;
  }(function (from) {
    return {
      to: function (_to) {
        function to(_x2) {
          return _to.apply(this, arguments);
        }

        to.toString = function () {
          return _to.toString();
        };

        return to;
      }(function (to) {
        return {
          via: function (_via) {
            function via(_x3) {
              return _via.apply(this, arguments);
            }

            via.toString = function () {
              return _via.toString();
            };

            return via;
          }(function (via) {
            return {
              from: from,
              to: to,
              via: via
            };
          })
        };
      })
    };
  })
};

function connectRelationToProp(many) {
  return function (model, relation, direction) {
    return function (target, name, descriptor) {
      if (descriptor) descriptor.writable = true;

      if (!target._relations) target._relations = [];
      target._relations.push({
        dest: model,
        relation: relation,
        out: direction ? direction === "out" : null,
        any: direction ? direction === "any" : null,
        propertyName: name,
        many: many
      });
    };
  };
}

var hasMany = exports.hasMany = connectRelationToProp(true);
var hasOne = exports.hasOne = connectRelationToProp(false);

var model = exports.model = function model(_model) {
  return function (target, name) {
    _utils.connectHelper.models.push({
      model: _model,
      relations: target.prototype._relations,
      modelInstance: target
    });
    _utils.connectHelper.tryInject();
  };
};

var defaultProps = exports.defaultProps = function defaultProps(props) {
  return function (target, name) {
    if (props) {
      target.prototype._defaultProps = props;
    }
  };
};

// Trust me flow, I know that's now optimal...I'm not happy either...
function extendModelInstance(instance) {
  // $FlowFixMe
  instance.hasMany = function (propertyName) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    return hasMany.apply(undefined, args)(instance.prototype, propertyName, null);
  };
  // $FlowFixMe
  instance.hasOne = function (propertyName) {
    for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
      args[_key2 - 1] = arguments[_key2];
    }

    return hasOne.apply(undefined, args)(instance.prototype, propertyName, null);
  };
  // $FlowFixMe
  instance.model = function () {
    return model.apply(undefined, arguments)(instance, "");
  };
  // $FlowFixMe
  instance.defaultProps = function () {
    return defaultProps.apply(undefined, arguments)(instance, "");
  };

  // $FlowFixMe
  return instance;
}