"use strict";

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = exports.hasOne = exports.add = exports.remove = exports.create = exports.get = undefined;

var get = exports.get = function () {
  var _ref = _asyncToGenerator(_regenerator2.default.mark(function _callee(instance, label, relationType) {
    var relationString, result;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            relationString = getRelationString(label, relationType);
            _context.next = 3;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{_srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    RETURN b\n  ", { _srcGuid: instance.props.guid });

          case 3:
            result = _context.sent;

            if (!(result.length === 0)) {
              _context.next = 6;
              break;
            }

            return _context.abrupt("return", _promise2.default.resolve(null));

          case 6:
            if (!(result.length > 1)) {
              _context.next = 8;
              break;
            }

            return _context.abrupt("return", _promise2.default.reject("hasOne has more than one relations"));

          case 8:
            return _context.abrupt("return", _promise2.default.resolve(this.dest._createModelInstance(result[0].b)));

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function get(_x2, _x3, _x4) {
    return _ref.apply(this, arguments);
  };
}();

var create = exports.create = function () {
  var _ref2 = _asyncToGenerator(_regenerator2.default.mark(function _callee2(instance, label, relationType, props) {
    var destInstance, relationString, result;
    return _regenerator2.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return this.dest.create(props);

          case 2:
            destInstance = _context2.sent;
            relationString = getRelationString(label, relationType);
            _context2.next = 6;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    DETACH DELETE b\n  ", { srcGuid: instance.props.guid });

          case 6:
            result = _context2.sent;
            _context2.next = 9;
            return _index2.default.run("\n    MATCH\n      (a:" + this.src.label + " {guid:{srcGuid}}),\n      (b:" + this.dest.label + " {guid:{destGuid}})\n    MERGE (a)" + relationString + "(b)\n  ", { srcGuid: instance.props.guid, destGuid: destInstance.props.guid });

          case 9:
            return _context2.abrupt("return", _promise2.default.resolve(destInstance));

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function create(_x5, _x6, _x7, _x8) {
    return _ref2.apply(this, arguments);
  };
}();

var remove = exports.remove = function () {
  var _ref3 = _asyncToGenerator(_regenerator2.default.mark(function _callee3(instance, label, relationType) {
    var relationString, result;
    return _regenerator2.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            relationString = getRelationString(label, relationType, "c");
            _context3.next = 3;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    DELETE c\n    ", { srcGuid: instance.props.guid });

          case 3:
            result = _context3.sent;
            return _context3.abrupt("return", _promise2.default.resolve(result._stats));

          case 5:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  }));

  return function remove(_x9, _x10, _x11) {
    return _ref3.apply(this, arguments);
  };
}();

var add = exports.add = function () {
  var _ref4 = _asyncToGenerator(_regenerator2.default.mark(function _callee4(instance, label, relationType, destInstance) {
    var relationString, result;
    return _regenerator2.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            relationString = getRelationString(label, relationType);
            _context4.next = 3;
            return _index2.default.run("\n    MATCH\n      (a:" + this.src.label + " {guid:{srcGuid}}),\n      (b:" + this.dest.label + " {guid:{destGuid}})\n    MERGE (a)" + relationString + "(b)\n  ", { srcGuid: instance.props.guid, destGuid: destInstance.props.guid });

          case 3:
            result = _context4.sent;

            if (!(result._stats.relationshipsCreated === 1)) {
              _context4.next = 6;
              break;
            }

            return _context4.abrupt("return", _promise2.default.resolve(true));

          case 6:
            return _context4.abrupt("return", _promise2.default.resolve(false));

          case 7:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  }));

  return function add(_x12, _x13, _x14, _x15) {
    return _ref4.apply(this, arguments);
  };
}();

var hasOne = exports.hasOne = function () {
  var _ref5 = _asyncToGenerator(_regenerator2.default.mark(function _callee5(instance, label, relationType) {
    var relationString, result;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            relationString = getRelationString(label, relationType);
            _context5.next = 3;
            return _index2.default.run("\n    MATCH\n      (a:" + this.src.label + " {guid:{srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    RETURN b\n  ", { srcGuid: instance.props.guid });

          case 3:
            result = _context5.sent;

            if (!(result.length === 1)) {
              _context5.next = 8;
              break;
            }

            return _context5.abrupt("return", _promise2.default.resolve(true));

          case 8:
            if (!(result.length > 1)) {
              _context5.next = 10;
              break;
            }

            return _context5.abrupt("return", _promise2.default.reject(new Error("HasOne relation has more than one relations")));

          case 10:
            return _context5.abrupt("return", _promise2.default.resolve(false));

          case 11:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));

  return function hasOne(_x16, _x17, _x18) {
    return _ref5.apply(this, arguments);
  };
}();

var update = exports.update = function () {
  var _ref6 = _asyncToGenerator(_regenerator2.default.mark(function _callee6(instance, label, relationType, newProps) {
    var relationString, props, destInstance;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            relationString = getRelationString(label, relationType);
            _context6.next = 3;
            return _index2.default.run("\n    MATCH (a:" + this.src.label + " {guid:{srcGuid}})" + relationString + "(b:" + this.dest.label + ")\n    RETURN b\n  ", { srcGuid: instance.props.guid });

          case 3:
            props = _context6.sent;

            if (!(props.length === 0)) {
              _context6.next = 8;
              break;
            }

            return _context6.abrupt("return", _promise2.default.resolve(true));

          case 8:
            if (!(props.length > 1)) {
              _context6.next = 10;
              break;
            }

            return _context6.abrupt("return", _promise2.default.reject(new Error("HasOne relation has more than one relations")));

          case 10:
            props = props[0].b;

            _context6.next = 13;
            return this.dest.update({ guid: props.guid }, newProps);

          case 13:
            destInstance = _context6.sent;

            if (!(destInstance.length === 1)) {
              _context6.next = 16;
              break;
            }

            return _context6.abrupt("return", _promise2.default.resolve(destInstance[0]));

          case 16:
            return _context6.abrupt("return", _promise2.default.reject(new Error("Problem with the update")));

          case 17:
          case "end":
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));

  return function update(_x19, _x20, _x21, _x22) {
    return _ref6.apply(this, arguments);
  };
}();

var _index = require("./index");

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _promise2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _promise2.default.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function getRelationString(label, relationType) {
  var variable = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";

  return (!relationType.out && !relationType.any ? "<" : "") + "-[" + variable + ":" + label + "]-" + (!relationType.out && !relationType.any ? "" : ">");
}