"use strict";

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _defineProperty = require("babel-runtime/core-js/object/define-property");

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Model = undefined;

var _extends = _assign2.default || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; (0, _defineProperty2.default)(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require("lodash");

var _uuid = require("uuid");

var _uuid2 = _interopRequireDefault(_uuid);

var _idx = require("idx");

var _idx2 = _interopRequireDefault(_idx);

var _index = require("./index");

var _index2 = _interopRequireDefault(_index);

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new _promise2.default(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return _promise2.default.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Model = exports.Model = function () {
  _createClass(Model, [{
    key: "beforeCreate",
    value: function beforeCreate(props) {
      return props;
    }
  }, {
    key: "afterCreate",
    value: function afterCreate(instance) {
      return instance;
    }
  }, {
    key: "beforeFind",
    value: function beforeFind(props) {
      return props;
    }
  }, {
    key: "afterFind",
    value: function afterFind(instance) {
      return instance;
    }
  }, {
    key: "beforeUpdate",
    value: function beforeUpdate(props, newProps) {
      return { props: props, newProps: newProps };
    }
  }, {
    key: "afterUpdate",
    value: function afterUpdate(instance) {
      return instance;
    }
  }, {
    key: "_createModelInstance",
    value: function _createModelInstance(props) {
      var instance = this.modelInstanceClass ? new this.modelInstanceClass(props) : new _index.ModelInstance(props);
      this.relations.forEach(function (r) {
        return instance = r.addFunctionsToInstance(instance);
      });
      return instance;
    }
  }]);

  function Model(label) {
    _classCallCheck(this, Model);

    this.label = label;
    this.relations = [];
  }

  _createClass(Model, [{
    key: "create",
    value: function () {
      var _ref2 = _asyncToGenerator(_regenerator2.default.mark(function _callee(props) {
        var _ref;

        var defaultProps, p, result;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                defaultProps = (0, _lodash.mapValues)(
                // $FlowFixMe
                ((_ref = this.modelInstanceClass) != null ? (_ref = _ref.prototype) != null ? _ref._defaultProps : _ref : _ref) || {}, function (prop) {
                  return typeof prop === "function" ? prop() : prop;
                });
                p = this.beforeCreate(_extends({ guid: (0, _uuid2.default)() }, defaultProps, props));

                p = _extends({}, p);

                _context.next = 5;
                return _index2.default.run("\n        CREATE (n:" + this.label + " {p})\n        RETURN n\n      ", { p: p });

              case 5:
                result = _context.sent;

                if (!(!result || result.length !== 1)) {
                  _context.next = 8;
                  break;
                }

                throw new Error("Create didn't work, cmd: \"CREATE (n:" + this.label + " {p}) RETURN n\" with params: " + (0, _stringify2.default)({ p: p }));

              case 8:
                return _context.abrupt("return", this.afterCreate(this._createModelInstance(result[0].n)));

              case 9:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function create(_x) {
        return _ref2.apply(this, arguments);
      }

      return create;
    }()
  }, {
    key: "findByGuid",
    value: function () {
      var _ref3 = _asyncToGenerator(_regenerator2.default.mark(function _callee2(guid) {
        var result;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return _index2.default.run("\n        MATCH (n:" + this.label + " {guid:{guid}})\n        RETURN n\n      ", { guid: guid });

              case 2:
                result = _context2.sent;

                if (!(!result || result.length > 1)) {
                  _context2.next = 5;
                  break;
                }

                throw new Error("Match didn't work, cmd: \"MATCH (n:" + this.label + " {guid:{guid}}) RETURN n\" with params: " + (0, _stringify2.default)({
                  guid: guid
                }));

              case 5:
                if (!(result.length === 0)) {
                  _context2.next = 7;
                  break;
                }

                return _context2.abrupt("return", null);

              case 7:
                return _context2.abrupt("return", this._createModelInstance(result[0].n));

              case 8:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function findByGuid(_x2) {
        return _ref3.apply(this, arguments);
      }

      return findByGuid;
    }()
  }, {
    key: "delete",
    value: function () {
      var _ref4 = _asyncToGenerator(_regenerator2.default.mark(function _callee3(props) {
        var detach = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

        var _prepareWhere, where, flatProps, result;

        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _prepareWhere = (0, _utils.prepareWhere)(props, "n"), where = _prepareWhere.where, flatProps = _prepareWhere.flatProps;
                _context3.next = 3;
                return _index2.default.run("\n        MATCH (n:" + this.label + ")\n        " + where + "\n        " + (detach ? " DETACH " : "") + " DELETE n\n      ", flatProps);

              case 3:
                result = _context3.sent;
                return _context3.abrupt("return", result._stats.nodesDeleted);

              case 5:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _delete(_x4) {
        return _ref4.apply(this, arguments);
      }

      return _delete;
    }()
  }, {
    key: "find",
    value: function () {
      var _ref5 = _asyncToGenerator(_regenerator2.default.mark(function _callee4(props) {
        var _this = this;

        var p, _prepareWhere2, where, flatProps, result;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                p = this.beforeFind(props);
                _prepareWhere2 = (0, _utils.prepareWhere)(p, "n"), where = _prepareWhere2.where, flatProps = _prepareWhere2.flatProps;
                _context4.next = 4;
                return _index2.default.run("\n        MATCH (n:" + this.label + ")\n        " + where + "\n        RETURN n\n      ", flatProps);

              case 4:
                result = _context4.sent;


                result = result.map(function (p) {
                  return _this.afterFind(_this._createModelInstance(p.n));
                });
                return _context4.abrupt("return", result);

              case 7:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function find(_x5) {
        return _ref5.apply(this, arguments);
      }

      return find;
    }()
  }, {
    key: "findOne",
    value: function () {
      var _ref6 = _asyncToGenerator(_regenerator2.default.mark(function _callee5(props) {
        var p, _prepareWhere3, where, flatProps, result;

        return _regenerator2.default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                p = this.beforeFind(props);
                _prepareWhere3 = (0, _utils.prepareWhere)(p, "n"), where = _prepareWhere3.where, flatProps = _prepareWhere3.flatProps;
                _context5.next = 4;
                return _index2.default.run("\n        MATCH (n:" + this.label + ")\n        " + where + "\n        RETURN n\n      ", flatProps);

              case 4:
                result = _context5.sent;

                if (!result.length) {
                  _context5.next = 7;
                  break;
                }

                return _context5.abrupt("return", this.afterFind(this._createModelInstance(result[0].n)));

              case 7:
                return _context5.abrupt("return", _promise2.default.resolve(null));

              case 8:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function findOne(_x6) {
        return _ref6.apply(this, arguments);
      }

      return findOne;
    }()
  }, {
    key: "update",
    value: function () {
      var _ref7 = _asyncToGenerator(_regenerator2.default.mark(function _callee6(props, newProps) {
        var _this2 = this;

        var params, _prepareWhere4, where, flatProps, _prepareSet, setPropsStr, _newProps, result;

        return _regenerator2.default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                params = this.beforeUpdate(props, newProps);
                _prepareWhere4 = (0, _utils.prepareWhere)(params.props, "n"), where = _prepareWhere4.where, flatProps = _prepareWhere4.flatProps;
                _prepareSet = (0, _utils.prepareSet)(params.newProps, "n"), setPropsStr = _prepareSet.str, _newProps = _prepareSet.newProps;
                _context6.next = 5;
                return _index2.default.run("\n        MATCH (n:" + this.label + ")\n        " + where + "\n        SET " + setPropsStr + "\n        RETURN n\n      ", _extends({}, flatProps, _newProps));

              case 5:
                result = _context6.sent;


                result = result.map(function (p) {
                  return _this2.afterUpdate(_this2._createModelInstance(p.n));
                });
                return _context6.abrupt("return", result);

              case 8:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function update(_x7, _x8) {
        return _ref7.apply(this, arguments);
      }

      return update;
    }()
  }]);

  return Model;
}();