"use strict";

var _defineProperty = require("babel-runtime/core-js/object/define-property");

var _defineProperty2 = _interopRequireDefault(_defineProperty);

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Relation = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; (0, _defineProperty2.default)(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require("./index");

var _index2 = _interopRequireDefault(_index);

var _utils = require("./utils");

var _HasManyRelation = require("./HasManyRelation");

var HasMany = _interopRequireWildcard(_HasManyRelation);

var _HasOneRelation = require("./HasOneRelation");

var HasOne = _interopRequireWildcard(_HasOneRelation);

var _idx = require("idx");

var _idx2 = _interopRequireDefault(_idx);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Relation = exports.Relation = function () {
  function Relation(src, property) {
    _classCallCheck(this, Relation);

    this.src = src;
    this.lazy = property;
    if ((0, _utils.lazy)(property.relation)) {
      this.init();
    }
  }

  /**
   * Initialise all lazy stuff
   */


  _createClass(Relation, [{
    key: "init",
    value: function init() {
      var property = (0, _utils.lazy)(this.lazy);
      if (!property) return;

      var relation = (0, _utils.lazy)(property.relation);
      if (!relation) return;

      var from = (0, _utils.lazy)(relation.from);
      var to = (0, _utils.lazy)(relation.to);
      if (!from || !to) return;

      this.relationType = {
        many: property.many,
        out: property.out !== null ? property.out : from === this.src,
        any: property.any
      };
      this.dest = (0, _utils.lazy)(from === this.src ? relation.to : relation.from);
      if (!this.dest) return;

      this.propertyName = property.propertyName;
      this.label = relation.via;
      delete this.lazy;
    }
  }, {
    key: "addFunctionsToInstance",
    value: function addFunctionsToInstance(instance) {
      if (this.lazy) this.init();
      if (this.relationType.many) {
        return this.addHasManyToInstance(instance);
      }
      return this.addHasOneToInstance(instance);
    }
  }, {
    key: "addHasManyToInstance",
    value: function addHasManyToInstance(instance) {
      var _this = this;

      // $FlowFixMe
      instance[this.propertyName] = {
        get: function get(props) {
          var relationProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          return HasMany.get.bind(_this, instance, _this.label, _this.relationType)(props, relationProps);
        },
        update: function update(options, whereProps) {
          var relationProps = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
          var whereRelationProps = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

          var optionsInUse = options.props || options.whereProps || options.relationProps || options.whereRelationProps;
          return HasMany.update.bind(_this, instance, _this.label, _this.relationType)(optionsInUse ? options.props : options, options.whereProps || whereProps, options.relationProps || relationProps, options.whereRelationProps || whereRelationProps);
        },
        remove: function remove(props) {
          var relationProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          return HasMany.remove.bind(_this, instance, _this.label, _this.relationType)(props, relationProps);
        },
        create: function create(props) {
          var relationProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          return HasMany.create.bind(_this, instance, _this.label, _this.relationType)(props, relationProps);
        },
        add: function add(instances) {
          var relationProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          return HasMany.add.bind(_this, instance, _this.label, _this.relationType)(instances, relationProps);
        },
        count: function count(props) {
          var relationProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
          return HasMany.count.bind(_this, instance, _this.label, _this.relationType)(props, relationProps);
        }
      };

      return instance;
    }
  }, {
    key: "addHasOneToInstance",
    value: function addHasOneToInstance(instance) {
      var _this2 = this;

      // $FlowFixMe
      instance[this.propertyName] = {
        get: function get() {
          return HasOne.get.bind(_this2, instance, _this2.label, _this2.relationType)();
        },
        update: function update(props, label) {
          return HasOne.update.bind(_this2, instance, _this2.label, _this2.relationType)(props);
        },
        create: function create(props, label) {
          return HasOne.create.bind(_this2, instance, _this2.label, _this2.relationType)(props);
        },
        add: function add(destInstance, label) {
          return HasOne.add.bind(_this2, instance, _this2.label, _this2.relationType)(destInstance);
        },
        remove: function remove(label) {
          return HasOne.remove.bind(_this2, instance, _this2.label, _this2.relationType)();
        },
        hasOne: function hasOne(label) {
          return HasOne.hasOne.bind(_this2, instance, _this2.label, _this2.relationType)();
        }
      };

      return instance;
    }
  }]);

  return Relation;
}();