"use strict";

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty = require("babel-runtime/core-js/object/define-property");

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = _assign2.default || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; (0, _defineProperty2.default)(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _types = require("./types");

(0, _keys2.default)(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  (0, _defineProperty2.default)(exports, key, {
    enumerable: true,
    get: function get() {
      return _types[key];
    }
  });
});

var _Model = require("./Model");

(0, _keys2.default)(_Model).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  (0, _defineProperty2.default)(exports, key, {
    enumerable: true,
    get: function get() {
      return _Model[key];
    }
  });
});

var _ModelInstance = require("./ModelInstance");

(0, _keys2.default)(_ModelInstance).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  (0, _defineProperty2.default)(exports, key, {
    enumerable: true,
    get: function get() {
      return _ModelInstance[key];
    }
  });
});

var _Relation = require("./Relation");

(0, _keys2.default)(_Relation).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  (0, _defineProperty2.default)(exports, key, {
    enumerable: true,
    get: function get() {
      return _Relation[key];
    }
  });
});

var _Decorators = require("./Decorators");

(0, _keys2.default)(_Decorators).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  (0, _defineProperty2.default)(exports, key, {
    enumerable: true,
    get: function get() {
      return _Decorators[key];
    }
  });
});

var _neo4jDriver = require("neo4j-driver");

var _idx = require("idx");

var _idx2 = _interopRequireDefault(_idx);

var _debug = require("debug");

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var d = (0, _debug2.default)("neo4js:debug");

var neo4js = function () {
  function neo4js() {
    var _this = this;

    _classCallCheck(this, neo4js);

    this.close = function () {
      d("Closing neo4js connection");
      _this.driver.close();
    };

    this.run = function (cmd, params) {
      var session = _this.driver.session();
      d("Cypher query: %s", cmd);
      d("Params: %O", params);
      return session.run(cmd, params).then(function (raw) {
        var _ref;

        d("Raw result: %O", raw);
        session.close();
        var result = raw.records.map(function (r) {
          return r.toObject();
        }).map(function (r) {
          var keys = (0, _keys2.default)(r);
          var o = {};
          keys.forEach(function (k) {
            return o[k] = r[k].properties;
          });
          return o;
        });
        result._stats = (_ref = raw) != null ? (_ref = _ref.summary) != null ? (_ref = _ref.counters) != null ? _ref._stats : _ref : _ref : _ref;
        result._raw = raw;
        d("Prepared result: %O", result);
        return result;
      }).catch(function (err) {
        session.close();
        throw err;
      });
    };
  }

  _createClass(neo4js, [{
    key: "init",
    value: function init(options) {
      this.options = _extends({}, options);

      // TODO: at least some verification...
      var uri = "bolt://" + this.options.boltUri + ":" + this.options.boltPort;
      var _options = this.options,
          username = _options.username,
          password = _options.password;

      var auth = undefined;
      if (username) {
        auth = _neo4jDriver.v1.auth.basic(username, password);
      }

      d("Init neo4js: %O", _extends({}, this.options, { uri: uri, username: username, password: password }));
      if (this.driver) this.close();
      this.driver = _neo4jDriver.v1.driver(uri, auth);
    }
  }]);

  return neo4js;
}();

exports.default = new neo4js();