"use strict";

var _defineProperty2 = require("babel-runtime/core-js/object/define-property");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _isIterable2 = require("babel-runtime/core-js/is-iterable");

var _isIterable3 = _interopRequireDefault(_isIterable2);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = (0, _getIterator3.default)(arr), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if ((0, _isIterable3.default)(Object(arr))) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = _assign2.default || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.prepareWhere = prepareWhere;
exports.prepareSet = prepareSet;

var _lodash = require("lodash");

var _CharGenerator = require("./CharGenerator");

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return (0, _from2.default)(arr); } }

function _defineProperty(obj, key, value) { if (key in obj) { (0, _defineProperty3.default)(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var singlePredicates = {
  $sw: "STARTS WITH",
  $ew: "ENDS WITH",
  $contains: "CONTAINS",
  $reg: "=~",

  $eq: "=",
  $in: "IN",

  $gt: ">",
  $gte: ">=",
  $lt: "<",
  $lte: "<="
};

function _prepareWhere(props, variable) {
  var where = [];
  var flatProps = {};

  if (!props) {
    return { where: [], flatProps: {} };
  }

  (0, _lodash.forIn)(props, function (v, k) {
    var propChar = _CharGenerator.CharGenerator.next();
    var found = false;

    if (v.$or) {
      found = true;
      var whereOr = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)(v.$or), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var predicate = _step.value;

          var tmp = _prepareWhere(_defineProperty({}, k, predicate), variable);
          whereOr.push.apply(whereOr, _toConsumableArray(tmp.where));
          flatProps = _extends({}, flatProps, tmp.flatProps);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      where.push("(" + whereOr.join(" OR ") + ")");
    } else if (v.$and) {
      found = true;
      var whereAnd = [];
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = (0, _getIterator3.default)(v.$and), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _predicate = _step2.value;

          var _tmp = _prepareWhere(_defineProperty({}, k, _predicate), variable);
          whereAnd.push.apply(whereAnd, _toConsumableArray(_tmp.where));
          flatProps = _extends({}, flatProps, _tmp.flatProps);
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      where.push("(" + whereAnd.join(" AND ") + ")");
    } else if (v.$not) {
      found = true;
      var _tmp2 = _prepareWhere(_defineProperty({}, k, v.$not), variable);
      if (_tmp2.where.length) {
        where.push("NOT " + _tmp2.where[0]);
        flatProps = _extends({}, flatProps, _tmp2.flatProps);
      }
    } else if (v.$between) {
      found = true;
      if (v.$between.length === 2) {
        var _v$$between = _slicedToArray(v.$between, 2),
            num1 = _v$$between[0],
            num2 = _v$$between[1];

        var a = propChar;
        var b = _CharGenerator.CharGenerator.next();
        where.push("{" + a + "} <= " + variable + "." + k + " <= {" + b + "}");
        flatProps[a] = num1 > num2 ? num2 : num1;
        flatProps[b] = num1 > num2 ? num1 : num2;
      }
      // TODO error? flow should actually be able to handle this...
    } else {
      (0, _lodash.forIn)(singlePredicates, function (predicateString, predicateKey) {
        var val = v[predicateKey];
        if (val || typeof val === "number" || typeof val === "string") {
          found = true;
          where.push(variable + "." + k + " " + predicateString + " {" + propChar + "}");
          flatProps[propChar] = v[predicateKey];
        }
      });
    }

    if (!found) {
      where.push(variable + "." + k + " = {" + propChar + "}");
      flatProps[propChar] = v;
    }
  });

  return { where: where, flatProps: flatProps };
}

function prepareWhere(properties, variables) {
  _CharGenerator.CharGenerator.start("a");
  var vars = [];
  var props = {};
  if (typeof variables === "string") {
    vars = [variables];
    props[variables] = properties;
  } else if (Array.isArray(variables)) {
    vars = variables;
    props = properties;
  }

  var where = [];
  var flatProps = {};
  vars.forEach(function (variable) {
    var result = _prepareWhere(props[variable], variable);
    where = where.concat(result.where);
    (0, _assign2.default)(flatProps, result.flatProps);
  });

  if (where.length === 0) {
    return { where: "", flatProps: undefined };
  }

  return { where: "WHERE " + where.join(" AND "), flatProps: flatProps };
}

function prepareSet(properties, variables) {
  var sets = [];
  var newProps = {};
  var vars = [];
  var props = {};
  if (typeof variables === "string") {
    vars = [variables];
    props[variables] = properties;
  } else if (Array.isArray(variables)) {
    vars = variables;
    props = properties;
  }

  vars.forEach(function (variable) {
    (0, _lodash.forIn)(props[variable], function (v, k) {
      if (k === "guid") return null;
      sets.push(variable + "." + k + "={_u_" + variable + "_" + k + "}");
      newProps["_u_" + variable + "_" + k] = v;
    });
  });

  if (!sets.length) throw new Error("Nothing to update");

  return { str: sets.join(", "), newProps: newProps };
}